include:
  - template: 'Workflows/MergeRequest-Pipelines.gitlab-ci.yml'

variables:
  GIT_STRATEGY: "none"
  DEBIAN_FRONTEND: "noninteractive"
  # NK_DKMS_PKG_NAMES:
  # NK_DKMS_PKG_PATTERN:

stages:
  - test

.test-template: &test-template
  stage: test
  image: ubuntu:${JOB_TARGET_SERIES}
  variables:
    # JOB_TARGET_SERIES:
    # JOB_KERNEL_REPO_PPA:
    # JOB_KERNEL_REPO_SOURCESLINE:
    # JOB_KERNEL_HEADER_PKG_NAMES:
    # JOB_ADDITIONAL_APT_KEYS:
  before_script:
    - apt-get update --quiet
    - apt-get install --no-install-recommends --yes
          dirmngr dkms gpg-agent software-properties-common
    - for key in ${JOB_ADDITIONAL_APT_KEYS}; do
        apt-key adv --batch --keyserver keyserver.ubuntu.com --recv-keys "${key}";
      done
    - for ppa in ${JOB_KERNEL_REPO_PPA}; do
        add-apt-repository --yes --no-update "${ppa}";
      done
    - if [ -n "${JOB_KERNEL_REPO_SOURCESLINE}" ]; then
        add-apt-repository --yes --no-update "${JOB_KERNEL_REPO_SOURCESLINE}";
      fi
    - apt-get update --quiet
    - apt-get install --no-install-recommends --yes ${JOB_KERNEL_HEADER_PKG_NAMES}
  script:
    - if [ -n "${NK_DKMS_PKG_NAMES}" ]; then
        apt-get install --no-install-recommends --yes ${NK_DKMS_PKG_NAMES};
      elif [ -n "${NK_DKMS_PKG_PATTERN}" ]; then
        apt-get install --no-install-recommends --yes
            $(apt-cache search --names-only "${NK_DKMS_PKG_PATTERN}" |
                awk "\$1 ~ /${NK_DKMS_PKG_PATTERN}/ {print \$1}" |
                sort -r | head -n 1);
      fi
  after_script:
    - mkdir output
    - |
      for log in /var/lib/dkms/*/*/build/make.log; do
        name=$(echo "${log}" | cut -d/ -f5);
        version=$(echo "${log}" | cut -d/ -f6);
        mv "${log}" output/"${name}_${version}.log";
      done
  artifacts:
    paths:
      - output
    when: always

bionic-proposed:
  extends: .test-template
  variables:
    JOB_TARGET_SERIES: "bionic"
    JOB_KERNEL_REPO_PPA: "ppa:canonical-kernel-team/proposed"
    JOB_KERNEL_HEADER_PKG_NAMES: "linux-headers-generic-hwe-18.04 linux-headers-generic-hwe-18.04-edge linux-headers-oem linux-headers-oem-osp1"
  rules:
    - if: '$NK_SKIP_BIONIC != "true"'

focal-proposed:
  extends: .test-template
  variables:
    JOB_TARGET_SERIES: "focal"
    JOB_KERNEL_REPO_PPA: "ppa:canonical-kernel-team/proposed"
    JOB_KERNEL_HEADER_PKG_NAMES: "linux-headers-generic-hwe-20.04 linux-headers-generic-hwe-20.04-edge linux-headers-oem-20.04"
  rules:
    - if: '$NK_SKIP_FOCAL != "true"'

groovy-proposed:
  extends: .test-template
  variables:
    JOB_TARGET_SERIES: "groovy"
    JOB_KERNEL_REPO_PPA: "ppa:canonical-kernel-team/proposed"
    JOB_KERNEL_HEADER_PKG_NAMES: "linux-headers-generic"
  rules:
    - if: '$NK_SKIP_GROOVY != "true"'

bootstrap:
  extends: .test-template
  variables:
    JOB_TARGET_SERIES: "devel"
    JOB_KERNEL_REPO_PPA: "ppa:canonical-kernel-team/bootstrap"
    JOB_KERNEL_HEADER_PKG_NAMES: "linux-headers-generic-wip"
  allow_failure: true
  rules:
    - if: '$NK_SKIP_BOOTSTRAP != "true"'
